"use strict";
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */define("Bastelstu.be/Chat/console",[],(function(){const e=Date.now();let t=e;const s=function(){window.console.group&&window.console.group()},i=function(){window.console.groupCollapsed&&window.console.groupCollapsed()},r=function(){window.console.groupEnd&&window.console.groupEnd()},n=function(e){for(var t=arguments.length,s=new Array(t>1?t-1:0),i=1;i<t;i++)s[i-1]=arguments[i];window.console[e](...s)},o=function(e){i();let t=`[${e.code}] ${e.message}`;const o=e=>e.split("\n").map((e=>e.replace(/<br\s*\/?>$/i,""))).join("\n");e.stacktrace?t+=`\nStacktrace:\n${o(e.stacktrace)}`:e.exceptionID&&(t+=`\nException ID: ${e.exceptionID}`),n("debug",t),e.previous.forEach((e=>{let t="";s(),t+=`${e.message}\n`,t+=`Stacktrace:\n${o(e.stacktrace)}`,n("debug",t)})),e.previous.forEach((e=>r())),r()};return{log:function(){for(var e=arguments.length,t=new Array(e),s=0;s<e;s++)t[s]=arguments[s];n("log",...t)},warn:function(){for(var e=arguments.length,t=new Array(e),s=0;s<e;s++)t[s]=arguments[s];n("warn",...t)},error:function(){for(var e=arguments.length,t=new Array(e),s=0;s<e;s++)t[s]=arguments[s];n("error",...t)},debug:function(s){const i=Date.now(),r=[i-e,`\t+${i-t}ms\t`];for(var o=arguments.length,a=new Array(o>1?o-1:0),l=1;l<o;l++)a[l-1]=arguments[l];a.length?n("debug",...r,`[${s}]\t`,...a):n("debug",...r,s),t=i},debugException:function(e){if(e instanceof Error){let t=`[${e.name}] „${e.message}“ in ${e.fileName} on line ${e.lineNumber}\n`;e.stack&&(t+="Stacktrace:\n",t+=e.stack),n("error",t)}else e.code&&e.message&&o(e)},group:s,groupCollapsed:i,groupEnd:r}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Parser",["Bastelstu.be/parser-combinator"],(function(e){const{C:t,F:s,N:i,X:r,parser:n,Streams:o}=e,a=e.parsec.response,l=s.satisfy((e=>/\s/.test(e))),c=s.any.optrep().map((e=>e.join(""))),h=s.any.rep().map((e=>e.join(""))),u=t.letter.or(i.digit).rep().map((e=>e.join(""))),d=s.not(t.letter.or(i.digit).or(l)).rep().map((e=>e.join(""))),p=t.char("/"),m=p.thenRight((g=p.map((e=>null)),new n((function(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0;return g.parse(e,t).fold((e=>a.accept(e.value,e.input,t,!1)),(t=>a.reject(e.location(t.offset),!1)))}))).or(u.thenLeft(l.rep().or(s.eos))).or(d.thenLeft(l.optrep()))).or(s.returns(null));var g;const f=m.then(c),b=t.char('"'),y=b.thenRight(b.thenRight(b).or(s.not(b)).rep()).thenLeft(b).map((e=>e.join(""))),C=t.char(","),E=s.not(C.or(b).or(l)).then(s.not(C.or(l)).optrep().map((e=>e.join("")))).map((e=>e.join(""))),S=y.or(E),w=e=>i.digit.occurrence(e).map((e=>parseInt(e.join(""),10))),D=i.digit.or(t.charIn("abcdefABCDEF")).rep().map((e=>e.join(""))),v=t.char("#").opt().thenRight(D.filter((e=>3===e.length||6===e.length)).map((e=>(3===e.length&&(e=`${e[0]}${e[0]}${e[1]}${e[1]}${e[2]}${e[2]}`),e)))).map((e=>`#${e}`)),T=t.char("-"),L=w(4).filter((e=>2e3<=e&&e<=2030)).thenLeft(T).then(w(2).filter((e=>1<=e&&e<=12))).thenLeft(T).then(w(2).filter((e=>1<=e))),I=t.char(":"),B=w(2).filter((e=>0<=e&&e<=23)).thenLeft(I).then(w(2).filter((e=>0<=e&&e<=59))).thenLeft(I).then(w(2).filter((e=>0<=e&&e<=59))),U=L.then(t.char("T").thenRight(B).opt()).map((function(e){let[t,s,i,r]=e;const n=new Date;return n.setFullYear(t),n.setMonth(s-1),n.setDate(i),r.map((function(e){let[t,s,i]=e;n.setHours(t),n.setMinutes(s),n.setSeconds(i)})),n}));return{Streams:o,stream:o,AlnumTrigger:u,Colon:I,Command:f,Dash:T,Datestring:L,Decimal:w,Hexadecimal:D,ISODate:U,Quote:b,QuotedUsername:y,RGBHex:v,Rest:c,Rest1:h,Slash:p,SymbolicTrigger:d,Timestring:B,Trigger:m,UnquotedUsername:E,Username:S,Whitespace:l,C:t,F:s,N:i,X:r}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/ParseError",[],(function(){class e extends Error{constructor(e,t){super(e),this.data=t}}return e})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/CommandHandler",["./Parser","./ParseError"],(function(e,t){class s{constructor(e,t){this.triggers=e,this.commands=t}splitCommand(s){const i=e.Command.parse(e.Streams.ofString(s));if(i.isAccepted())return i.value;throw new t("Empty trigger")}applyCommand(s,i){const r=s.getParameterParser().parse(e.Streams.ofString(i));if(r.isAccepted())return r.value;throw new t("Could not parse",{result:r,parameterString:i})}getTriggers(){return this.triggers.keys()}getCommandByTrigger(e){const t=this.triggers.get(e);return null==t?null:this.getCommandByIdentifier(...t)}getCommandByIdentifier(e,t){return this.commands[`${e.replace(/\./g,"-")}:${t}`]}}return s.DEPENDENCIES=["Trigger","Command"],s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Autocompleter",["./CommandHandler","./Parser"],(function(e,t){class s{constructor(t){if(!(t instanceof e))throw new TypeError("You must pass a CommandHandler to the Autocompleter");this.commandHandler=t}*autocomplete(e){if("/"===e)return void(yield*this.autocompleteCommandTrigger(e,""));const[s,i]=this.commandHandler.splitCommand(e);let r;if(null===s)r=this.commandHandler.getCommandByIdentifier("be.bastelstu.chat","plain");else{if(!t.Slash.thenRight(t.AlnumTrigger.or(t.SymbolicTrigger).thenLeft(t.Whitespace)).parse(t.Streams.ofString(e)).isAccepted())return void(yield*this.autocompleteCommandTrigger(e,s));r=this.commandHandler.getCommandByTrigger(s)}if(null===r)return;const n=r.autocomplete(i);if(null!==s)for(const e of n)yield`/${s} ${e}`;else yield*n}*autocompleteCommandTrigger(e,t){const s=Array.from(this.commandHandler.getTriggers());s.sort();for(const e of s)""!==e&&e.startsWith(t)&&this.commandHandler.getCommandByTrigger(e).isAvailable&&(yield`/${e} `)}}return s.DEPENDENCIES=["CommandHandler"],s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/DataStructure/Throttle",[],(function(){class e{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:125;if("function"!=typeof e)throw new Error("Callback must be a function.");if(t<0)throw new Error("Delay must be non-negative.");this.callback=e,this._delay=t,this.hot=!1,this.awaiting=!1,this.timer=null,this.last=Date.now()}setTimer(){null!=this.timer&&clearTimeout(this.timer),this.timer=setTimeout((e=>{this.timer=null,this.hot=!1,this.awaiting&&this.execute()}),this.delay)}execute(){this.awaiting=!1,this.hot=!0,this.last=Date.now(),this.setTimer(),this.callback()}guardedExecute(){this.hot?this.awaiting=!0:this.execute()}get delay(){return this._delay}set delay(e){this.awaiting&&Date.now()-this.last>e?(this._delay=0,this.setTimer()):this.timer&&(this._delay=Math.max(0,e-(Date.now()-this.last)),this.setTimer()),this._delay=e}}return function(t){const s=new e(t,arguments.length>1&&void 0!==arguments[1]?arguments[1]:125),i=s.guardedExecute.bind(s);return i.setDelay=function(e){s.delay=e},i.getDelay=function(){return s.delay},i}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Helper",["WoltLabSuite/Core/Date/Util","WoltLabSuite/Core/Language"],(function(e,t){class s{static deepFreeze(e){return Object.getOwnPropertyNames(e).forEach((function(t){let i=e[t];"object"==typeof i&&null!==i&&s.deepFreeze(i)})),Object.freeze(e)}static isInput(e){if("INPUT"===e.tagName){if("text"!==e.getAttribute("type")&&"password"!==e.getAttribute("type"))return!1}else if("TEXTAREA"!==e.tagName)return!1;return!0}static throttle(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:250,s=arguments.length>2?arguments[2]:void 0,i=0,r=null;return function(){const n=(new Date).getTime(),o=arguments,a=s||this;return i&&n<i+t?(clearTimeout(r),r=setTimeout((function(){return i=n,e.apply(a,o)}),t)):(i=n,e.apply(a,o))}}static getCaret(e){if(!s.isInput(e))throw new Error("Unsupported element");let t=0;return e.selectionStart&&(t=e.selectionStart),t}static setCaret(e,t){if(!s.isInput(e))throw new Error("Unsupported element");e.selectionStart&&(e.focus(),e.setSelectionRange(t,t))}static wrapElement(e,t){return t=t||document.createElement("div"),e.nextSibling?e.parentNode.insertBefore(t,e.nextSibling):e.parentNode.appendChild(t),t.appendChild(e)}static makeFlexible(e){if("TEXTAREA"!==e.tagName)throw new Error(`Unsupported element type: ${e.tagName}`);const t=document.createElement("pre"),i=document.createElement("span"),r=function(){i.textContent=e.value};e.parentNode.classList.contains("flexibleTextarea")||(s.wrapElement(e),e.parentNode.classList.add("flexibleTextarea")),e.removeAttribute("rows"),e.classList.add("flexibleTextareaContent"),t.classList.add("flexibleTextareaMirror"),t.appendChild(i),t.appendChild(document.createElement("br")),e.parentNode.insertBefore(t,e),e.addEventListener("input",r),r()}static getCircularArray(e){return new class extends Array{constructor(e){super(),Object.defineProperty(this,"size",{enumerable:!1,value:e,writable:!1,configurable:!1})}push(){return super.push.apply(this,arguments),this.length>this.size&&super.shift(),this.length}unshift(){return super.unshift.apply(this,arguments),this.length>this.size&&super.pop(),this.length}first(){return this[0]}last(){return this[this.length-1]}}(e)}static intToRGBHex(e){const t=(e>>16&255).toString(16),s=(e>>8&255).toString(16),i=(e>>0&255).toString(16);return`#${1==t.length?`0${t}`:t}${1==s.length?`0${s}`:s}${1==i.length?`0${i}`:i}`}static getTimeElementHTML(t){const s=t.getTime()>(new Date).getTime();let i="";if(s&&(i=e.formatDateTime(t)),"function"==typeof e.getTimeElement){const r=e.getTimeElement(t);return s&&(r.innerText=i),r.outerHTML}return`<time class="datetime"\n\t\t\t\t      datetime="${e.format(t,"c")}"\n\t\t\t\t      data-date="${e.formatDate(t)}"\n\t\t\t\t      data-time="${e.formatTime(t)}"\n\t\t\t\t      data-offset="${60*t.getTimezoneOffset()}"\n\t\t\t\t      data-timestamp="${(t.getTime()-t.getMilliseconds())/1e3}"\n\t\t\t\t      ${s?'data-is-future-date="true"':""}\n\t\t\t\t>${i}</time>`}
/**
     * Returns whether the supplied selection range covers the whole text inside the given node
     *
     * Source: https://stackoverflow.com/a/27686686/1112384
     *
     * @param  {Range} range Selection range
     * @param  {Node}
     * @return {Boolean}
     */static rangeSpansTextContent(e,t){const s=document.createTreeWalker(t,NodeFilter.SHOW_TEXT);let i,r;for(;s.nextNode();)""!==s.currentNode.nodeValue.trim()&&(i||(i=s.currentNode),r=s.currentNode);const n=e.cloneRange();i?(n.setStart(i,0),n.setEnd(r,r.length)):n.selectNodeContents(t);const o=e.compareBoundaryPoints(Range.START_TO_START,n),a=e.compareBoundaryPoints(Range.END_TO_END,n);return o<1&&a>-1}static getTextContent(e){let t="";const s=NodeFilter.SHOW_TEXT|NodeFilter.SHOW_ELEMENT,i=document.createTreeWalker(e,s,{acceptNode:e=>e instanceof Element&&("SCRIPT"===e.tagName||"STYLE"===e.tagName)?NodeFilter.FILTER_REJECT:NodeFilter.FILTER_ACCEPT}),r=[];for(;i.nextNode();){const e=i.currentNode;if(e instanceof Text){if("A"===e.parentNode.tagName&&r.indexOf(e.parentNode)>=0)continue;t+=e.nodeValue.replace(/\n/g,"")}else switch(e.tagName){case"IMG":{const s=e.getAttribute("alt");e.classList.contains("smiley")?t+=` ${s} `:t+=s&&""!==s?` ${s} [Image ${e.src}] `:` [Image ${e.src}] `;break}case"BR":case"LI":case"UL":case"DIV":case"TR":t+="\n";break;case"TH":case"TD":t+="\t";break;case"P":t+="\n\n";break;case"A":{let s=e.href;const i=e.textContent.trim();if(""!==i&&i!==e.href){r.push(e);let t=!1;if(i.indexOf("…")>=0){const s=i.split(/\u2026/);2===s.length&&(t=e.href.startsWith(s[0])&&e.href.endsWith(s[1]))}t||(s=`${e.textContent} [URL:${e.href}]`)}t+=s;break}}}return t}static getElementSiblings(e){if(!e||!e.parentNode)return;const t=[...e.parentNode.children],s=t.indexOf(e);return[...t.slice(0,s),...t.slice(s+1)]}}return s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Message",["./Helper","WoltLabSuite/Core/Date/Util","WoltLabSuite/Core/User"],(function(e,t,s){const i=Symbol("message");return class{constructor(t,s){this[i]=e.deepFreeze(s),this.MessageType=t}get messageID(){return this[i].messageID}get objectType(){return this[i].objectType}getMessageType(){return this.MessageType[this.objectType.replace(/\./g,"-")]}get time(){return this[i].time}get formattedTime(){return t.format(this.date,"H:i:s")}get date(){return new Date(1e3*this[i].time)}get link(){return this[i].link}get userID(){return this[i].userID}get username(){return this[i].username}get isIgnored(){return this[i].isIgnored}get isDeleted(){return this[i].isDeleted}get payload(){return this[i].payload}isOwnMessage(){return this.userID===s.userId}wrap(){return{message:this[i]}}toJSON(){return this[i]}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/User",["WoltLabSuite/Core/User","WoltLabSuite/Core/StringUtil","./Helper"],(function(e,t,s){const i=Symbol("user");class r{constructor(e){this[i]=s.deepFreeze(e),Object.getOwnPropertyNames(this[i]).forEach((e=>{if(this[e])throw new Error("Attempting to override existing property");Object.defineProperty(this,e,{value:this[i][e],enumerable:!0})}))}get coloredUsername(){if(null===this.color1&&null===this.color2)return this.username;if(this.color1===this.color2)return`<span style="color: ${s.intToRGBHex(this.color1)};">${t.escapeHTML(this.username)}</span>`;const e=this.color1>>16&255,r=this.color2>>16&255,n=this.color1>>8&255,o=this.color2>>8&255,a=255&this.color1,l=255&this.color2,c=this.username.length-1,h=(e-r)/c,u=(n-o)/c,d=(a-l)/c;return this[i].username.split("").map(((s,i)=>`<span style="color: rgb(${Math.round(e-i*h)}, ${Math.round(n-i*u)}, ${Math.round(a-i*d)})">${t.escapeHTML(s)}</span>`)).join("")}get self(){return this.userID===e.userId}static getGuest(e){return new r({username:e,userID:null,color1:null,color2:null})}wrap(){return{user:this[i]}}toJSON(){return this[i]}}return r})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Room",["Bastelstu.be/PromiseWrap/Ajax","WoltLabSuite/Core/Core","./User"],(function(e,t,s){class i{constructor(e,t){this.sessionID=e,this.roomID=t}async join(){const t={className:"chat\\data\\room\\RoomAction",actionName:"join",parameters:{roomID:this.roomID,sessionID:this.sessionID}};return e.api(this,t)}leave(){let s=arguments.length>0&&void 0!==arguments[0]&&arguments[0];const i={className:"chat\\data\\room\\RoomAction",actionName:"leave",parameters:{roomID:this.roomID,sessionID:this.sessionID}};if(s&&FormData&&(navigator.sendBeacon||window.fetch)){const e=WSC_API_URL+"index.php?ajax-proxy/&t="+SECURITY_TOKEN,s=new FormData;return t.serialize(i).split("&").map((e=>e.split("="))).map((e=>e.map(decodeURIComponent))).forEach((e=>s.append(e[0],e[1]))),navigator.sendBeacon&&navigator.sendBeacon(e,s),window.fetch&&fetch(e,{method:"POST",keepalive:!0,redirect:"follow",body:s}),Promise.resolve()}return e.api(this,i)}async getUsers(){const t={className:"chat\\data\\room\\RoomAction",actionName:"getUsers",objectIDs:[this.roomID]},i=await e.api(this,t);return Object.values(i.returnValues).map((e=>new s(e)))}_ajaxSetup(){return{silent:!0,ignoreError:!0}}}return i.DEPENDENCIES=["sessionID","roomID"],i})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Messenger",["./console","Bastelstu.be/PromiseWrap/Ajax","./Room"],(function(e,t,s){class i{constructor(e,t,i){if(!(t instanceof s))throw new TypeError("You must pass a Room to the Messenger");this.sessionID=e,this.room=t,this.Message=i}async pull(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:0,s=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];const r={actionName:"pull",parameters:{inLog:i}};if(0!==e&&0!==s)throw new Error("You must not set both from and to");0!==e&&(r.parameters.from=e),0!==s&&(r.parameters.to=s);const n=await t.api(this,r),o=Object.values(n.returnValues.messages).map((e=>this.Message.instance(e))),{from:a,to:l}=n.returnValues;return{messages:o,from:a,to:l}}async push(e){let{commandID:s,parameters:i}=e;const r={actionName:"push",parameters:{commandID:s,parameters:JSON.stringify(i)}};return t.api(this,r)}async pushAttachment(e){const s={actionName:"pushAttachment",parameters:{tmpHash:e}};return t.api(this,s)}_ajaxSetup(){return{silent:!0,ignoreError:!0,data:{className:"chat\\data\\message\\MessageAction",parameters:{roomID:this.room.roomID,sessionID:this.sessionID}}}}}return i.DEPENDENCIES=["sessionID","Room","Message"],i})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/DataStructure/LRU",[],(function(){const e=Symbol("s"),t=Symbol("start");class s{constructor(){this[e]=new Map,this[t]=void 0}add(s){if(this[t]&&this[t].value===s)return;if(this[e].has(s)){const t=this[e].get(s);t.prev&&(t.prev.next=t.next),t.next&&(t.next.prev=t.prev)}const i={value:s,next:this[t],prev:void 0};this[t]=i,this[t].next&&(this[t].next.prev=i),this[e].set(s,i)}*[Symbol.iterator](){let e=this[t];do{yield e.value}while(e=e.next)}}return s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/ProfileStore",["Bastelstu.be/PromiseWrap/Ajax","./DataStructure/LRU","./User","WoltLabSuite/Core/User"],(function(e,t,s,i){class r{constructor(){this.users=new Map,this.processing=new Map,this.lastActivity=new t}async ensureUsersByIDs(t){t=t.filter(((e,t,s)=>s.indexOf(e)===t)).map((e=>parseInt(e,10)));const i=[],r=[];if(t.forEach(function(e){this.isRecent(e)||(this.processing.has(e)?r.push(this.processing.get(e)):i.push(e))}.bind(this)),i.length>0){const t={actionName:"getUsersByID",parameters:{userIDs:i}},n=(async r=>{try{const i=await e.api(this,t);return Object.entries(i.returnValues).forEach((e=>{let[t,i]=e;t=parseInt(t,10);const r={user:new s(i),date:Date.now()};this.users.set(t,r),this.processing.delete(t)}))}catch(e){throw i.forEach((e=>this.processing.delete(e))),e}})();i.forEach((e=>this.processing.set(e,n))),r.push(n)}await Promise.all(r)}async getUsersByIDs(e){return await this.ensureUsersByIDs(e),new Map(e.map((e=>[e,this.get(e)])))}getSelf(){const e=this.get(i.userId);if(null==e)throw new Error("Unreachable");return e}get(e){const t=this.users.get(e);return null!=t?t.user:t}has(e){return this.users.has(e)}expire(e){this.users.has(e)&&(this.users.get(e).date=0)}isRecent(e){const t=this.users.get(e);return null!=t&&t.date>Date.now()-3e5}values(){return Array.from(this.users.values()).map((e=>e.user))}pushLastActivity(e){e&&this.lastActivity.add(e)}*getLastActivity(){yield*this.lastActivity}_ajaxSetup(){return{silent:!0,ignoreError:!0,data:{className:"chat\\data\\user\\UserAction"}}}}return r.DEPENDENCIES=[],r})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Template",["WoltLabSuite/Core/Template"],(function(e){return class extends e{constructor(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};super(e),this.templates=t;const s=this.fetch;this.fetch=function(e){e=Object.assign({},e);const t=Object.assign({},this.templates,e.t||{});return e.t=t,s.call(this,e)}.bind(this)}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/DataStructure/EventEmitter",[],(function(){const e=new WeakMap;return function(t){Object.assign(t,{on(t,s){let i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};e.has(this)||e.set(this,new Map),e.get(this).has(t)||e.get(this).set(t,new Set),i.once||(i.once=!1),e.get(this).get(t).add({listener:s,options:i})},off(t,s){e.get(this).get(t).delete(s)},emit(t){let s=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(!e.has(this))return;if(!e.get(this).has(t))return;const i=e.get(this).get(t);i.forEach(function(e){let{listener:t,options:r}=e;r.once&&i.delete(t),t({target:this,detail:s})}.bind(this))}})}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Attachment/Upload",["WoltLabSuite/Core/Core","WoltLabSuite/Core/Language","WoltLabSuite/Core/Upload","WoltLabSuite/Core/Dom/Change/Listener","WoltLabSuite/Core/Dom/Util","WoltLabSuite/Core/Ui/Dialog","../../DataStructure/EventEmitter"],(function(e,t,s,i,r,n,o){const a="chatAttachmentUploadDialog";class l extends s{constructor(e,t){const s=document.querySelector(`#${a} > .upload`),i=r.identify(s),n=document.querySelector(`#${a} > .attachmentPreview`);super(i,r.identify(n),{className:"wcf\\data\\attachment\\AttachmentAction"}),this.input=e,this.room=t,this.previewContainer=n,this.tmpHash=void 0}bootstrap(){this.uploadDescription=document.querySelector(`#${a} > small`);const e=document.getElementById("chatAttachmentUploadButton"),t=document.getElementById(a);if(elHide(t),t.classList.remove("jsStaticDialogContent"),t.dataset.isStaticDialog="true",e){e.addEventListener("click",(e=>{e.preventDefault(),n.openStatic(t.id,null,{title:elData(t,"title"),onShow:()=>this.showDialog(),onClose:()=>this.onClose()})}));new WCF.Action.Delete("wcf\\data\\attachment\\AttachmentAction",`#${this.previewContainer.id} > p`).setCallback((()=>this.onAbort())),this.input.on("input",(t=>{0==t.target.input.value.length?e.classList.remove("disabled"):e.classList.add("disabled")}))}}onAbort(){this.deleteOnClose=!1,this.closeDialog()}onClose(){this.deleteOnClose&&e.triggerEvent(this.cancelButton,"click")}closeDialog(){n.getDialog(a)&&n.close(a)}showDialog(){this.deleteOnClose=!1,this._button.parentNode&&this._removeButton(),this._target.innerHTML="",this._createButton(),elShow(this.uploadDescription)}createButtons(e,s,r){const n=elCreate("div");n.classList.add("formSubmit","dialogFormSubmit"),this.sendButton=document.createElement("button"),this.sendButton.classList.add("button","buttonPrimary"),this.sendButton.innerText=t.get("wcf.global.button.submit"),this.sendButton.addEventListener("click",(e=>this.send(r,e))),n.appendChild(this.sendButton),this.cancelButton=document.createElement("button"),this.cancelButton.classList.add("button","jsDeleteButton"),this.cancelButton.dataset.objectId=s,this.cancelButton.dataset.eventName="attachment",this.cancelButton.innerText=t.get("wcf.global.button.cancel"),n.appendChild(this.cancelButton);this._fileElements[e][0].appendChild(n),i.trigger()}async send(e,t){t.preventDefault();const s={promise:Promise.resolve(),tmpHash:e};this.emit("send",s);try{await s.promise,this.deleteOnClose=!1,this.closeDialog()}catch(e){console.error(e);let t=this._target.querySelector(".error");t||(t=document.createElement("div"),t.classList.add("error"),this._target.insertBefore(t,this._target.firstChild)),t.innerText=e.message,n.rebuild(a)}}_getParameters(){return this.tmpHash=[...crypto.getRandomValues(new Uint8Array(20))].map((e=>("0"+e.toString(16)).slice(-2))).join(""),{objectType:"be.bastelstu.chat.message",parentObjectID:this.room.roomID,tmpHash:this.tmpHash}}_success(e,s,i,o,l){const c=this._fileElements[e][0].querySelector(":scope > progress");if(s.returnValues.errors&&s.returnValues.errors[e]){const i=s.returnValues.errors[e];return elInnerError(this._button,t.get(`wcf.attachment.upload.error.${i.errorType}`,{filename:i.filename})),void c.remove()}if(elInnerError(this._button,""),s.returnValues.attachments&&s.returnValues.attachments[e]){this.deleteOnClose=!0,this._removeButton(),elHide(this.uploadDescription);const t=s.returnValues.attachments[e];if(t.isImage){const e=t.thumbnailURL||t.tinyURL||t.url;if(!e)throw new Error("Missing image URL");const s=document.createElement("img");s.setAttribute("src",e),s.setAttribute("alt",""),e===t.tinyURL?s.classList.add("attachmentTinyThumbnail"):s.classList.add("attachmentThumbnail"),s.dataset.width=t.width,s.dataset.height=t.height,r.replaceElement(c,s)}else{const e=document.createElement("a");e.setAttribute("href",t.url),e.innerText=t.filename,r.replaceElement(c,e)}this.createButtons(e,t.attachmentID,this.tmpHash),n.rebuild(a)}else console.error("Received neither an error nor an attachment response"),console.error(s.returnValues)}}return l.DEPENDENCIES=["UiInput","Room"],o(l.prototype),l})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/LocalStorageEmulator",[],(function(){class e{constructor(){return this._data=new Map,new Proxy(this,{get:(e,t)=>e.hasOwnProperty(t)||Object.getPrototypeOf(e)[t]?e[t]:e.getItem(t),set(e,t,s){e.hasOwnProperty(t)||Object.getPrototypeOf(e)[t]?e[t]=s:e.setItem(t,s)},has:(e,t)=>e.hasOwnProperty(t)||Object.getPrototypeOf(e)[t]||e._data.has(t),ownKeys:e=>Array.from(e._data.keys()),getOwnPropertyDescriptor:(e,t)=>({enumerable:!0,configurable:!0})})}get length(){return this._data.size}key(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:0;return Array.from(this._data.keys())[e]}getItem(e){return this._data.get(e)}setItem(e,t){this._data.set(e,t)}removeItem(e){this._data.delete(e)}clear(){this._data.clear()}*[Symbol.iterator](){yield*this._data.values()}}return e})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/LocalStorage",["WoltLabSuite/Core/Core","./LocalStorageEmulator"],(function(e,t){class s{constructor(e){this.subprefix=e,this.hasLocalStorage=!1,this.setupStorage()}static isQuotaExceeded(e){return e instanceof DOMException&&(22===e.code||1014===e.code||"QuotaExceededError"===e.name||"NS_ERROR_DOM_QUOTA_REACHED"===e.name)}static isAvailable(){try{const e="__storage_test__";return window.localStorage.setItem(e,e),window.localStorage.removeItem(e),!0}catch(e){return s.isQuotaExceeded(e)}}setupStorage(){s.isAvailable()?(this.storage=window.localStorage,this.hasLocalStorage=!0):(console.info("Falling back to in-memory local storage emulation"),this.storage=new t)}get storagePrefix(){let t="";return"function"==typeof e.getStoragePrefix&&(t=e.getStoragePrefix()),`${t}be.bastelstu.Chat.${this.subprefix}`}observe(e,t){window.addEventListener("storage",(s=>{s.storageArea===window.localStorage&&s.key===`${this.storagePrefix}${e}`&&t(s)}))}set(e,i){try{this.storage.setItem(`${this.storagePrefix}${e}`,JSON.stringify(i))}catch(e){if(!s.isQuotaExceeded(e))throw e;console.warn("Your localStorage has exceeded the size quota for this domain"),console.warn("We are falling back to an in-memory storage, this does not persist data!"),console.error(e);const i=new t;for(let e=0;e<localStorage.length;e++){const t=localStorage.key(e),s=localStorage.getItem(t);i.setItem(t,s)}this.storage=i}return this.get(e)}get(e){const t=this.storage.getItem(`${this.storagePrefix}${e}`);return null==t?null:JSON.parse(t)}has(e){return null!=this.storage.getItem(`${this.storagePrefix}${e}`)}remove(e){const t=this.get(e),s=`${this.storagePrefix}${e}`;return this.storage.removeItem(s),t}clear(){const e=e=>{for(let t in e)t.startsWith(this.storagePrefix)&&e.hasOwnProperty(t)&&e.removeItem(t)};if(this.hasLocalStorage&&this.storage instanceof t)try{e(localStorage);const t="__storage_test__";window.localStorage.setItem(t,t),window.localStorage.removeItem(t),this.storage=localStorage,console.log("Switched back to using the localStorage")}catch(e){}e(this.storage)}}return s.DEPENDENCIES=[],s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/AutoAway",["../console","../CommandHandler","../LocalStorage","../Messenger","../ProfileStore","WoltLabSuite/Core/Language","WoltLabSuite/Core/Timer/Repeating"],(function(e,t,s,i,r,n,o){class a{constructor(e,n,o,a,l){if(!(n instanceof t))throw new TypeError("You must pass a CommandHandler to the AutoAway");if(!(o instanceof i))throw new TypeError("You must pass a Messenger to the AutoAway");if(!(a instanceof r))throw new TypeError("You must pass a ProfileStore to the AutoAway");if(this.storage=new s("AutoAway."),this.awayCommand=n.getCommandByIdentifier("be.bastelstu.chat","away"),null==this.awayCommand)throw new Error("Unreachable");this.config=e,this.messenger=o,this.input=l,this.profileStore=a}bootstrap(){0!==this.config.autoAwayTime&&this.awayCommand.isAvailable&&(this.timer=new o(this.setAway.bind(this),6e4*this.config.autoAwayTime),this.input.on("input",this.inputListener=e=>{this.storage.set("channel",Date.now()),this.reset()}),this.storage.observe("channel",this.reset.bind(this)))}ingest(e){e.some((e=>e.isOwnMessage()))&&this.reset()}reset(){this.timer&&this.timer.setDelta(6e4*this.config.autoAwayTime)}async setAway(){this.storage.get("setAway")>=Date.now()-1e4||(this.storage.set("setAway",Date.now()),this.profileStore.getSelf().away||this.messenger.push({commandID:this.awayCommand.id,parameters:{reason:n.get("chat.user.autoAway")}}))}}return a.DEPENDENCIES=["config","CommandHandler","Messenger","ProfileStore","UiInput"],a})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui",[],(function(){return class{constructor(){}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Chat",["../Ui"],(function(e){class t extends e{constructor(e,t,s,i,r,n,o,a,l,c,h,u,d,p){super(),this.actionDropdownHandler=d,this.attachmentUpload=e,this.autoAway=t,this.autocompleter=r,this.connectionWarning=s,this.input=i,this.messageActionDelete=n,this.messageStream=o,this.mobile=a,this.notification=l,this.readMarker=c,this.settings=h,this.topic=u,this.userList=p}bootstrap(){this.actionDropdownHandler.bootstrap(),this.attachmentUpload.bootstrap(),this.autoAway.bootstrap(),this.autocompleter.bootstrap(),this.connectionWarning.bootstrap(),this.input.bootstrap(),this.messageActionDelete.bootstrap(),this.messageStream.bootstrap(),this.mobile.bootstrap(),this.notification.bootstrap(),this.readMarker.bootstrap(),this.settings.bootstrap(),this.topic.bootstrap(),this.userList.bootstrap()}}return t.DEPENDENCIES=["UiAttachmentUpload","UiAutoAway","UiConnectionWarning","UiInput","UiInputAutocompleter","UiMessageActionDelete","UiMessageStream","UiMobile","UiNotification","UiReadMarker","UiSettings","UiTopic","UiUserActionDropdownHandler","UiUserList"],t})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/ConnectionWarning",["../console"],(function(e){return class{constructor(){this.warning=elById("chatConnectionWarning")}bootstrap(){}show(){elShow(this.warning),this.timeout||(this.timeout=setTimeout((e=>{this.timeout=void 0,this.autoHide&&this.hide()}),1e4))}hide(){let e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];!this.timeout||e?(elHide(this.warning),window.clearTimeout(this.timeout)):this.autoHide=!0}toggle(){elToggle(this.warning)}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/ErrorDialog",["WoltLabSuite/Core/Language","WoltLabSuite/Core/Template","WoltLabSuite/Core/Ui/Dialog"],(function(e,t,s){const i=['[type="x-text/template"]','[data-application="be.bastelstu.chat"]','[data-template-name="be-bastelstu-chat-errorDialog"]'].join(""),r=new t(elBySel(i).textContent);return class{constructor(t){const i={title:e.get("wcf.global.error.title"),closable:!1};s.openStatic("chatError",r.fetch({message:t}),i)}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Input",["../console","../Helper","WoltLabSuite/Core/Core","WoltLabSuite/Core/Event/Key","../DataStructure/EventEmitter","../DataStructure/Throttle"],(function(e,t,s,i,r,n){class o{constructor(){this.inputContainer=elById("chatInputContainer"),this.input=elBySel("textarea",this.inputContainer),this.charCounter=elBySel(".charCounter",this.inputContainer),this.errorElement=elBySel(".innerError",this.inputContainer)}bootstrap(){"function"==typeof window.elInnerError&&elRemove(this.errorElement),this.input.addEventListener("keydown",this.handleInputKeyDown.bind(this)),this.input.addEventListener("input",n(this.handleInput.bind(this))),t.makeFlexible(this.input),this.handleInput()}handleInput(e){this.charCounter.textContent=`${this.input.value.length} / ${this.input.getAttribute("maxlength")}`,this.emit("input")}handleInputKeyDown(e){if(i.Enter(e)&&!e.shiftKey){if(e.isComposing)return;if(e.preventDefault(),0===this.getText().length)return;const t={cancel:!1,input:this};this.emit("beforeSubmit",t),t.cancel||this.emit("submit")}else i.Tab(e)&&(e.preventDefault(),this.emit("autocomplete"))}getText(){return arguments.length>0&&void 0!==arguments[0]&&arguments[0]?this.input.value:this.input.value.trim()}select(e){let t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:void 0;void 0===t&&(t=this.getText(!0).length),this.input.setSelectionRange(e,t)}focus(){this.input.focus()}insertText(e,t){this.focus(),(t=Object.assign({append:!0,prepend:!1},t)).append||t.prepend||(this.input.value=e),t.append&&(this.input.value+=e),t.prepend&&(this.input.value=e+this.input.value);const i=this.input.value.length;this.input.setSelectionRange(i,i),s.triggerEvent(this.input,"input")}inputError(e){"function"==typeof window.elInnerError?elInnerError(this.inputContainer.firstElementChild,e):(this.inputContainer.classList.add("formError"),this.errorElement.textContent=e,elShow(this.errorElement))}hideInputError(){"function"==typeof window.elInnerError?elInnerError(this.inputContainer.firstElementChild,!1):(this.inputContainer.classList.remove("formError"),this.errorElement.textContent="",elHide(this.errorElement))}}return r(o.prototype),o})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Input/Autocompleter",["WoltLabSuite/Core/Dom/Util","WoltLabSuite/Core/Event/Key","WoltLabSuite/Core/Ui/Suggestion"],(function(e,t,s){class i extends s{constructor(t){super(e.identify(t.input),{callbackSelect:(e,t)=>this.insertSelection(t)}),this.input=t,this.completions=new Map,this.completionId=0}bootstrap(){this.input.on("beforeSubmit",(e=>{e.target===this.input&&((this.isActive()||this.cancelNextSubmit)&&(e.detail.cancel=!0),this.cancelNextSubmit=!1)}))}keyDown(){return this._keyDown(...arguments)}_keyDown(e){!(super.keyDown||super._keyDown).call(this,e)&&t.Enter(e)&&(this.cancelNextSubmit=!0)}keyUp(){return this._keyUp(...arguments)}_keyUp(e){const t=this.input.getText(!0);this._value!==t&&(this.sendCompletions([]),this._value=t)}insertSelection(e){let t;(t=this.completions.get(parseInt(e.objectId,10)))&&this.input.insertText(t,{append:!1})}sendCompletions(e){this.completions=new Map;const t=e.map((e=>(this.completions.set(++this.completionId,e),{label:e,objectID:this.completionId})));this._ajaxSuccess({returnValues:t})}}return i.DEPENDENCIES=["UiInput"],i})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/DataStructure/RedBlackTree/Node",[],(function(){return class{constructor(e){this.value=e,this._left=void 0,this._right=void 0,this.parent=void 0,this.color="RED"}get left(){return this._left}set left(e){if(this._left&&(this._left.parent=void 0),void 0!==e){if(void 0!==e.parent)if(e.isLeftChild)e.parent.left=void 0;else{if(!e.isRightChild)throw new Error("Unreachable");e.parent.right=void 0}e.parent=this}this._left=e}get right(){return this._right}set right(e){if(this._right&&(this._right.parent=void 0),void 0!==e){if(void 0!==e.parent)if(e.isLeftChild)e.parent.left=void 0;else{if(!e.isRightChild)throw new Error("Unreachable");e.parent.right=void 0}e.parent=this}this._right=e}get isRoot(){return void 0===this.parent}get isLeaf(){return void 0===this.left&&void 0===this.right}get isLeftChild(){return void 0!==this.parent&&this.parent.left===this}get isRightChild(){return void 0!==this.parent&&this.parent.right===this}get grandparent(){if(void 0!==this.parent)return this.parent.parent}get sibling(){if(void 0!==this.parent)return this.isLeftChild?this.parent.right:this.parent.left}get uncle(){if(void 0!==this.parent)return this.parent.sibling}search(e){if(e===this.value)return["IS",this];if(e<this.value)return void 0!==this.left?this.left.search(e):["LEFT",this];if(e>this.value)return void 0!==this.right?this.right.search(e):["RIGHT",this];throw new Error("Unreachable")}print(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:0;console.log("  ".repeat(e)+`${this.value}: ${this.color} (Parent: ${this.parent?this.parent.value:"-"})`),this.left?this.left.print(e+1):console.log("  ".repeat(e+1)+"-"),this.right?this.right.print(e+1):console.log("  ".repeat(e+1)+"-")}check(){if(this.left&&this.left.value>=this.value)throw new Error("Invalid"+this.value);if(this.right&&this.right.value<=this.value)throw new Error("Invalid"+this.value);if("RED"===this.color&&(this.left&&"BLACK"!==this.left.color||this.right&&"BLACK"!==this.right.color))throw new Error("Invalid"+this.value);let e=1,t=1;if(this.left&&(e=this.left.check()),this.right&&(t=this.right.check()),e!==t)throw new Error("Invalid"+this.value);return"BLACK"===this.color?e+1:e}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/DataStructure/RedBlackTree/Tree",["./Node"],(function(e){return class{constructor(){this.root=void 0}search(e){if(void 0!==this.root)return this.root.search(e)}insert(t){const s=new e(t);if(void 0===this.root)return this.root=s,this.fix(s),["RIGHT",void 0];const i=this.search(t),[r,n]=i;if("IS"===r)return[r,n.value];if("LEFT"===r)return n.left=s,this.fix(s),[r,n.value];if("RIGHT"===r)return n.right=s,this.fix(s),[r,n.value];throw new Error("Unreachable")}fix(e){if(void 0===e.parent)return void(e.color="BLACK");if("BLACK"===e.parent.color)return;const t=e.uncle;if(void 0!==t&&"RED"===t.color){e.parent.color="BLACK",t.color="BLACK";const s=e.grandparent;return s.color="RED",void this.fix(s)}e.isRightChild&&e.parent.isLeftChild?(this.rotateLeft(e.parent),e=e.left):e.isLeftChild&&e.parent.isRightChild&&(this.rotateRight(e.parent),e=e.right);const s=e.grandparent;e.parent.color="BLACK",s.color="RED",e.isLeftChild?this.rotateRight(s):this.rotateLeft(s)}rotateLeft(e){if(void 0===e.right)return;const t=e.right;e.right=t.left,void 0===e.parent?this.root=t:e.isLeftChild?e.parent.left=t:e.isRightChild&&(e.parent.right=t),t.left=e}rotateRight(e){if(void 0===e.left)return;const t=e.left;e.left=t.right,void 0===e.parent?this.root=t:e.isLeftChild?e.parent.left=t:e.isRightChild&&(e.parent.right=t),t.right=e}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/MessageStream",["../Helper","WoltLabSuite/Core/Date/Util","WoltLabSuite/Core/Dom/Change/Listener","WoltLabSuite/Core/Language","WoltLabSuite/Core/User","WoltLabSuite/Core/Dom/Traverse","../DataStructure/EventEmitter","../DataStructure/RedBlackTree/Tree"],(function(e,t,s,i,r,n,o,a){const l=Symbol("enableAutoscroll");class c{constructor(){this.stream=elById("chatMessageStream"),this.scrollContainer=elBySel(".scrollContainer",this.stream),this[l]=!0,this.lastScrollPosition=void 0,this.nodeMap=new WeakMap,this.positions=new a}get enableAutoscroll(){return this[l]}set enableAutoscroll(e){this[l]=e,this[l]&&this.scrollToBottom()}bootstrap(){this.scrollContainer.addEventListener("copy",this.onCopy.bind(this)),this.scrollContainer.addEventListener("scroll",e.throttle(this.onScroll,100,this),{passive:!0})}getDateMarker(e){const s=elCreate("li");s.classList.add("dateMarker");const i=elCreate("time");return i.innerText=t.formatDate(e),i.setAttribute("datetime",t.format(e,"Y-m-d")),s.appendChild(i),s}onDifferentDays(e,s){return t.format(e,"Y-m-d")!==t.format(s,"Y-m-d")}ingest(e){let t=this.enableAutoscroll?0:this.scrollContainer.scrollTop,i=0;const n=elBySel("ul",this.scrollContainer),o=(n.firstElementChild,e.map(function(e){let t=0;const s=elCreate("li");let o;if(!1===(o=e.getMessageType().render(e)))return;o.querySelector(`.userMention[data-user-id="${r.userId}"]`)&&s.classList.add("mentioned"),s.appendChild(o),s.classList.add("chatMessageBoundary"),s.setAttribute("id",`message-${e.messageID}`),s.dataset.objectType=e.objectType,s.dataset.userId=e.userID,e.isOwnMessage()&&s.classList.add("own"),e.isDeleted&&s.classList.add("tombstone");const a=this.positions.insert(e.messageID);if(void 0!==a[1]){const r=elById(`message-${a[1]}`);if(!r)throw new Error("Unreachable");let o,l;if("LEFT"===a[0])l=r,o=r.previousElementSibling,o&&o.classList.contains("dateMarker")&&(elRemove(o),o=r.previousElementSibling);else{if("RIGHT"!==a[0])throw new Error("Unreachable");o=r,l=r.nextElementSibling,l&&l.classList.contains("dateMarker")&&(elRemove(l),l=r.nextElementSibling)}const c=this.nodeMap.get(o);if(o&&!c)throw new Error("Unreachable");const h=this.nodeMap.get(l);if(l&&!h)throw new Error("Unreachable");!this.enableAutoscroll&&l&&(t=this.scrollContainer.scrollHeight);let u=l;if(l&&l.classList.remove("first"),c)if(this.onDifferentDays(c.date,e.date)){const t=this.getDateMarker(e.date);n.insertBefore(t,l),s.classList.add("first")}else c.objectType===e.objectType&&e.getMessageType().joinable(c,e)||s.classList.add("first");else s.classList.add("first");if(h)if(this.onDifferentDays(h.date,e.date)){const e=this.getDateMarker(h.date);n.insertBefore(e,l),u=e,l.classList.add("first")}else h.objectType===e.objectType&&e.getMessageType().joinable(e,h)||l.classList.add("first");n.insertBefore(s,u),!this.enableAutoscroll&&l&&(i+=this.scrollContainer.scrollHeight-t)}else s.classList.add("first"),n.insertBefore(s,null);return this.nodeMap.set(s,e),{node:s,message:e}}.bind(this)));o.some((e=>null!=e))&&(this.enableAutoscroll?this.scrollToBottom():(this.stream.classList.add("activity"),this.scrollContainer.scrollTop=t+i)),s.trigger(),this.emit("ingested",o)}scrollToBottom(){this.scrollContainer.scrollTop=this.scrollContainer.scrollHeight,this.stream.classList.remove("activity")}onScroll(){const{scrollTop:e,scrollHeight:t,clientHeight:s}=this.scrollContainer,i=e,r=t-e-s;let n="down";null!=this.lastScrollPosition&&e<this.lastScrollPosition&&(n="up"),"up"===n?(r>7&&this.emit("scrollUp"),i<=7?this.emit("reachedTop"):i<=300&&this.emit("nearTop")):"down"===n&&(i>7&&this.emit("scrollDown"),r<=7?(this.scrollToBottom(),this.emit("reachedBottom")):r<=300&&this.emit("nearBottom")),this.lastScrollPosition=e}onCopy(t){const s=window.getSelection();if(s.isCollapsed)return;let r,o,a,l;o=r=s.getRangeAt(0).startContainer,a=l=s.getRangeAt(s.rangeCount-1).endContainer;const c=s.getRangeAt(0).startOffset,h=s.getRangeAt(s.rangeCount-1).endOffset;for(;!(o instanceof Element)&&o.parentNode;)o=o.parentNode;for(;!(a instanceof Element)&&a.parentNode;)a=a.parentNode;if(!o||!a)throw new Error("Unexpected error, no element nodes in selection");if(o.id&&0===o.id.indexOf("message-")||(o=n.parentBySel(o,"li[id^='message']",this.stream)),a.id&&0===a.id.indexOf("message-")||(a=n.parentBySel(a,"li[id^='message']",this.stream)),r instanceof Text&&""===r.textContent.substring(c)&&(o=n.next(o)),null===a&&(a=elBySel("ul > li:last-child",this.stream)),o===a&&0===h)return;o!==a&&0===h&&(a=n.prev(a));const u=[];let d=o;do{if(u.push(d),d===a)break}while(d=n.next(d));if(1===u.length){const t=document.createRange();if(t.setStart(r,c),t.setEnd(l,h),!e.rangeSpansTextContent(t,o.querySelector(".chatMessage")))return}try{t.clipboardData.setData("text/plain",u.map(((t,s,r)=>{const n=this.nodeMap.get(t);if(t.classList.contains("dateMarker"))return`== ${t.textContent.trim()} ==`;if(!n)return;if(t.classList.contains("tombstone"))return`[${n.formattedTime}] ${i.get("chat.messageType.be.bastelstu.chat.messageType.tombstone.message")}`;const o=elBySel(".chatMessage",t);let a;return void 0!==(a=n.getMessageType().renderPlainText(n))&&!1!==a||(a=e.getTextContent(o).replace(/\t+/g,"\t").replace(/ +/g," ").replace(/([\t ]*\n){2,}/g,"\n").replace(/^[\t ]+|[\t ]+$/gm,"")),`[${n.formattedTime}] <${n.username}> ${a.trim()}`})).filter((e=>e)).join("\n")),t.preventDefault()}catch(e){console.error("Unable to use the clipboard API"),console.error(e)}}}return o(c.prototype),c.DEPENDENCIES=[],c})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/MessageActions/Delete",["Bastelstu.be/Chat/Message","Bastelstu.be/PromiseWrap/Ajax","Bastelstu.be/PromiseWrap/Ui/Confirmation"],(function(e,t,s){class i{constructor(e,t){this.messageStream=e,this.Message=t}bootstrap(){this.messageStream.on("ingested",this.bindListener.bind(this))}bindListener(e){let{detail:t}=e;t.forEach((e=>{if(!e)return;const{node:t,message:i}=e,r=t.querySelector(".jsDeleteButton");r&&r.addEventListener("click",(async e=>{e.preventDefault(),await s.show({message:r.dataset.confirmMessageHtml,messageIsHtml:!0}),await this.delete(i.messageID),elRemove(r.closest("li"))}))}))}async delete(e){{const s={objectIDs:[e]};await t.api(this,s)}{const t="be.bastelstu.chat.messageType.tombstone",s={messageID:e,userID:null},i=this.Message.instance({objectType:t,payload:s});i.getMessageType().render(i)}}_ajaxSetup(){return{silent:!0,ignoreError:!0,data:{className:"chat\\data\\message\\MessageAction",actionName:"trash"}}}}return i.DEPENDENCIES=["UiMessageStream","Message"],i})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Mobile",["WoltLabSuite/Core/Ui/Screen"],(function(e){const t=Symbol("initialized");return class{constructor(){this[t]=!1}bootstrap(){e.on("screen-md-down",{match:this.enable.bind(this),unmatch:this.disable.bind(this),setup:this.init.bind(this)})}init(){this[t]||(this[t]=!0,this.initQuickSettings())}enable(){}disable(){}initQuickSettings(){const e=elBySel("#chatQuickSettingsNavigation > ul"),t=elById("chatQuickSettings");e.addEventListener(WCF_CLICK_EVENT,(t=>{t.stopPropagation(),window.setTimeout((()=>{e.classList.remove("open")}),10)})),t.addEventListener(WCF_CLICK_EVENT,(t=>{t.preventDefault(),t.stopPropagation(),e.classList.toggle("open")}))}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Notification",["WoltLabSuite/Core/Language"],(function(e){class t{constructor(e){this.profileStore=e,this.unread=0,this.active=!0,this.browserTitle=document.title,this.systemEnabled=!1,this.lastSeen=0}bootstrap(){document.addEventListener("visibilitychange",this.onVisibilitychange.bind(this))}get systemSupported(){return"Notification"in window}get systemDenied(){return"denied"===window.Notification.permission}get systemGranted(){return this.systemDenied&&console.warn("[Notification]","System Notifications: permission denied"),"granted"===window.Notification.permission}onVisibilitychange(){this.active=!document.hidden,this.active&&(this.unread=0,this.updateBrowserTitle())}ingest(t){this.active||t.forEach((t=>{const s=t.getMessageType().renderPlainText(t);if(!1!==s&&!(t.messageID<this.lastSeen)&&(this.lastSeen=t.messageID,this.unread++,this.systemEnabled&&this.systemGranted)){const i=this.profileStore.get(t.userID),r=e.get("chat.notification.title",{message:t}),n={body:s,icon:i.imageUrl,badge:i.imageUrl},o=new window.Notification(r,n);setTimeout(o.close.bind(o),5e3)}})),this.updateBrowserTitle()}updateBrowserTitle(){this.unread>0?document.title=`(${this.unread}) ${this.browserTitle}`:document.title=this.browserTitle}enableSystemNotifications(){return this.systemSupported?this.systemGranted?(this.systemEnabled=!0,Promise.resolve()):new Promise(((e,t)=>{window.Notification.requestPermission((s=>{this.systemEnabled="granted"===s,this.systemEnabled?e():t(new Error(s))}))})):Promise.reject(new Error("Notifications are not supported"))}disableSystemNotifications(){this.systemEnabled=!1}}return t.DEPENDENCIES=["ProfileStore"],t})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/ReadMarker",[],(function(){class e{constructor(e){this.messageStream=e}bootstrap(){document.addEventListener("visibilitychange",this.onVisibilitychange.bind(this))}onVisibilitychange(){if(document.hidden){let e=elBySel("ul",this.messageStream.stream).lastElementChild;Array.prototype.forEach.call(document.querySelectorAll(".readMarker"),(e=>{e.classList.remove("readMarker")})),e&&e.classList.add("readMarker")}}}return e.DEPENDENCIES=["UiMessageStream"],e})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Settings",[],(function(){class e{constructor(e){this.modules=e,this.buttons=Array.from(elBySelAll("#chatQuickSettingsNavigation .button[data-module]"))}bootstrap(){this.buttons.forEach((e=>{this.modules[e.dataset.module.replace(/\./g,"-")].instance(e).bootstrap()}))}}return e.DEPENDENCIES=["UiSettingsButton"],e})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Topic",["WoltLabSuite/Core/Dom/Traverse"],(function(e){return class{bootstrap(){elBySelAll(".chatRoomTopic",document,(function(e){elBySel(".jsDismissRoomTopicButton",e).addEventListener("click",(function(t){elRemove(e)}))}))}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/UserActionDropdownHandler",["WoltLabSuite/Core/Dom/Traverse","WoltLabSuite/Core/Dom/Util","WoltLabSuite/Core/Ui/Dropdown/Simple"],(function(e,t,s){class i{constructor(e,t,s){this.profiles=e,this.dropdownTemplate=t,this.bottle=s,this.container=elById("main")}bootstrap(){this.container.addEventListener("click",this.onClick.bind(this))}onClick(i){const r=i.target.classList.contains("jsUserActionDropdown")?i.target:e.parentByClass(i.target,"jsUserActionDropdown",this.container);if(!r)return;i.preventDefault(),i.stopPropagation();const n=this.profiles.get(parseInt(r.dataset.userId,10));if(null==n)throw new Error("Unreachable");const o=t.createFragmentFromHtml(this.dropdownTemplate.fetch({user:n})).querySelector("*");Array.from(elBySelAll("[data-module]",o)).forEach((e=>{const t=e.dataset.module;let s;this.bottle.container.UserAction&&null!=(s=this.bottle.container.UserAction[`${t.replace(/\./g,"-")}`])||(this.bottle.factory(`UserAction.${t.replace(/\./g,"-")}`,(e=>{const s=require(t);return new s(...this.bottle.digest(s.DEPENDENCIES||[]))})),s=this.bottle.container.UserAction[`${t.replace(/\./g,"-")}`]),e.addEventListener(WCF_CLICK_EVENT,(e=>s.onClick(n,e)))})),s.initFragment(r,o),s.registerCallback(r.id,((e,t)=>{"close"===t&&s.destroy(e)})),s.toggleDropdown(r.id)}}return i.DEPENDENCIES=["ProfileStore","Template.UserListDropdownMenuItems","bottle"],i})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/UserList",["WoltLabSuite/Core/Dom/Util"],(function(e){class t{constructor(e){this.userListTemplate=e,this.chatUserList=elById("chatUserList")}bootstrap(){}render(t){t.sort(((e,t)=>e.username.localeCompare(t.username)));const s=this.userListTemplate.fetch({users:t}),i=e.createFragmentFromHtml(s),r=elBySel("#chatUserList > .boxContent > ul"),n=r.parentNode;n.removeChild(r),n.appendChild(i)}}return t.DEPENDENCIES=["Template.UserList"],t})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat",["./Chat/console","Bastelstu.be/bottle","Bastelstu.be/_Push","WoltLabSuite/Core/Core","WoltLabSuite/Core/Language","WoltLabSuite/Core/Timer/Repeating","WoltLabSuite/Core/User","./Chat/Autocompleter","./Chat/CommandHandler","./Chat/DataStructure/Throttle","./Chat/Message","./Chat/Messenger","./Chat/ParseError","./Chat/ProfileStore","./Chat/Room","./Chat/Template","./Chat/Ui/Attachment/Upload","./Chat/Ui/AutoAway","./Chat/Ui/Chat","./Chat/Ui/ConnectionWarning","./Chat/Ui/ErrorDialog","./Chat/Ui/Input","./Chat/Ui/Input/Autocompleter","./Chat/Ui/MessageStream","./Chat/Ui/MessageActions/Delete","./Chat/Ui/Mobile","./Chat/Ui/Notification","./Chat/Ui/ReadMarker","./Chat/Ui/Settings","./Chat/Ui/Topic","./Chat/Ui/UserActionDropdownHandler","./Chat/Ui/UserList"],(function(e,t,s,i,r,n,o,a,l,c,h,u,d,p,m,g,f,b,y,C,E,S,w,D,v,T,L,I,B,U,M,x){return class{constructor(e,s){this.config=s,this.sessionID=i.getUuid(),this.bottle=new t,this.bottle.value("bottle",this.bottle),this.bottle.value("config",s),this.bottle.constant("sessionID",this.sessionID),this.bottle.constant("roomID",e),this.service("Autocompleter",a),this.service("CommandHandler",l),this.service("Messenger",u),this.service("ProfileStore",p),this.service("Room",m),this.service("Ui",y),this.service("UiAutoAway",b),this.service("UiConnectionWarning",C),this.service("UiInput",S),this.service("UiInputAutocompleter",w),this.service("UiMessageActionDelete",v),this.service("UiMessageStream",D),this.service("UiMobile",T),this.service("UiNotification",L),this.service("UiReadMarker",I),this.service("UiSettings",B),this.service("UiTopic",U),this.service("UiUserActionDropdownHandler",M),this.service("UiUserList",x),this.service("UiAttachmentUpload",f),this.bottle.instanceFactory("Message",((e,t)=>new h(e.MessageType,t)));const r=['[type="x-text/template"]','[data-application="be.bastelstu.chat"]',"[data-template-name]"].join(""),n=elBySelAll(r);Array.prototype.forEach.call(n,function(e){this.bottle.factory(`Template.${e.dataset.templateName}`,(function(t){const s=(e.dataset.templateIncludes||"").split(/ /).filter((e=>""!==e)),i={};return s.forEach((e=>i[e]=t[e])),new g(e.textContent,i)}))}.bind(this)),Object.entries(this.config.messageTypes).forEach((e=>{let[t,s]=e;const i=require(s.module);this.bottle.factory(`MessageType.${t.replace(/\./g,"-")}`,(e=>{const s=this.bottle.digest(i.DEPENDENCIES||[]);return new i(...s,t)}))})),Object.values(this.config.commands).forEach((e=>{const t=require(e.module);this.bottle.factory(`Command.${e.package.replace(/\./g,"-")}:${e.identifier}`,(s=>{const i=this.bottle.digest(t.DEPENDENCIES||[]);return new t(...i,e)}))})),this.bottle.constant("Trigger",new Map(Object.entries(this.config.triggers).map((e=>{let[t,s]=e;const i=this.config.commands[s];return[t,[i.package,i.identifier]]})))),Array.from(elBySelAll("#chatQuickSettingsNavigation .button[data-module]")).forEach((e=>{const t=require(e.dataset.module);this.bottle.instanceFactory(`UiSettingsButton.${e.dataset.module.replace(/\./g,"-")}`,((e,s)=>{const i=this.bottle.digest(t.DEPENDENCIES||[]);return new t(s,...i)}))})),this.knows={from:void 0,to:void 0},this.processMessagesThrottled=c(this.processMessages.bind(this)),this.queuedMessages=[],this.messageSinks=new Set,this.pullTimer=void 0,this.pullUserListTimer=void 0,this.pushConnected=!1,this.firstFailure=null}service(e,t){let s=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[];this.bottle.factory(e,(e=>{const i=this.bottle.digest(t.DEPENDENCIES||[]);return new t(...i,...s)}))}async bootstrap(){return this.ui=this.bottle.container.Ui,this.ui.bootstrap(),this.ui.input.on("submit",this.onSubmit.bind(this)),this.ui.input.on("autocomplete",this.onAutocomplete.bind(this)),this.ui.attachmentUpload.on("send",(e=>{e.detail.promise=this.onSendAttachment(e)})),await this.bottle.container.Room.join(),window.addEventListener("unload",this.bottle.container.Room.leave.bind(this.bottle.container.Room,!0)),document.addEventListener("visibilitychange",(e=>{this.processMessagesThrottled.setDelay(document.hidden?1e4:125)})),this.pullTimer=new n(c(this.pullMessages.bind(this)),1e3*this.config.reloadTime),s.onConnect((e=>{this.pushConnected=!0,this.pullTimer.setDelta(3e4)})).catch((e=>{})),s.onDisconnect((e=>{this.pushConnected=!1,this.pullTimer.setDelta(1e3*this.config.reloadTime)})).catch((e=>{})),s.onMessage("be.bastelstu.chat.message",this.pullMessages.bind(this)).catch((e=>{})),this.pullUserListTimer=new n(this.updateUsers.bind(this),6e4),this.registerMessageSink(this.bottle.container.UiMessageStream),this.registerMessageSink(this.bottle.container.UiNotification),this.registerMessageSink(this.bottle.container.UiAutoAway),await Promise.all([this.pullMessages(),this.updateUsers(),this.bottle.container.ProfileStore.ensureUsersByIDs([o.userId])]),this}registerMessageSink(e){if("function"!=typeof e.ingest)throw new Error("The given sink does not provide a .ingest function.");this.messageSinks.add(e)}unregisterMessageSink(e){this.messageSinks.delete(e)}hcf(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:void 0;this.pullTimer.stop(),this.pullUserListTimer.stop(),new E(r.get("chat.error.hcf",{err:e}))}async onSubmit(e){const t=e.target,s=t.getText();t.insertText("",{append:!1}),this.markAsBack();let[i,n]=this.bottle.container.CommandHandler.splitCommand(s),o=null;if(o=null===i?this.bottle.container.CommandHandler.getCommandByIdentifier("be.bastelstu.chat","plain"):this.bottle.container.CommandHandler.getCommandByTrigger(i),null!==o)try{let e;try{e=this.bottle.container.CommandHandler.applyCommand(o,n)}catch(e){throw e instanceof d&&(e=new Error(r.get("chat.error.invalidParameters",{data:e.data}))),e}const t={commandID:o.id,parameters:e};try{await this.bottle.container.Messenger.push(t),this.ui.input.hideInputError()}catch(e){let t=!0;e.returnValues&&"message"===e.returnValues.fieldName&&(e.returnValues.realErrorMessage||e.returnValues.errorType)?(this.ui.input.inputError(e.returnValues.realErrorMessage||e.returnValues.errorType),t=!1):this.ui.input.inputError(e.message),t&&this.handleError(e)}this.pushConnected||this.pullMessages()}catch(e){this.ui.input.inputError(e.message)}else this.ui.input.inputError(r.get("chat.error.triggerNotFound",{trigger:i}))}async markAsBack(){try{if(null==this.bottle.container.ProfileStore.getSelf().away)return;const e=this.bottle.container.CommandHandler.getCommandByIdentifier("be.bastelstu.chat","back");return this.bottle.container.Messenger.push({commandID:e.id,parameters:{}})}catch(t){e.error("Chat.markAsBack",t)}}async onSendAttachment(e){await this.bottle.container.Messenger.pushAttachment(e.detail.tmpHash),this.markAsBack()}onAutocomplete(e){const t=e.target.getText(!0),s=this.bottle.container.Autocompleter.autocomplete(t),i=[];for(const e of s)if(i.push(e),5==i.length)break;this.ui.autocompleter.sendCompletions(i)}async pullMessages(){let e;this.knows.to&&this.knows.to;try{e=void 0===this.knows.to?await this.bottle.container.Messenger.pull():await this.bottle.container.Messenger.pull(this.knows.to+1)}catch(e){return void this.handleError(e)}(performance||Date).now();if(this.ui.connectionWarning.hide(),this.firstFailure=null,e.from>e.to){(performance||Date).now();return}let t=e.messages;void 0!==this.knows.from&&void 0!==this.knows.to&&(t=t.filter((e=>!(this.knows.from<=e.messageID&&e.messageID<=this.knows.to)))),(void 0===this.knows.from||e.from<this.knows.from)&&(this.knows.from=e.from),(void 0===this.knows.to||e.to>this.knows.to)&&(this.knows.to=e.to),this.queuedMessages.push(t);(performance||Date).now();this.processMessagesThrottled()}handleError(t){null===this.firstFailure&&(e.error("Chat.handleError","Request failed, 30 seconds until shutdown"),this.firstFailure=Date.now(),this.ui.connectionWarning.show()),e.debugException(t),Date.now()-this.firstFailure>=3e4&&(e.error("Chat.handleError"," Failures for 30 seconds, aborting"),this.hcf(t))}async processMessages(){(performance||Date).now();const e=[].concat(...this.queuedMessages);if(this.queuedMessages=[],0===e.length)return;await Promise.all(e.map((async e=>(this.bottle.container.ProfileStore.pushLastActivity(e.userID),e.getMessageType().preProcess(e)))));e.some((e=>e.getMessageType().shouldUpdateUserList(e)))&&this.updateUsers(),await this.bottle.container.ProfileStore.ensureUsersByIDs([].concat(...e.map((e=>e.getMessageType().getReferencedUsers(e))))),e.forEach((e=>{e.getMessageType().preRender(e)})),this.messageSinks.forEach((t=>t.ingest(e)));(performance||Date).now()}async updateUsers(){const e=await this.bottle.container.Room.getUsers();await this.bottle.container.ProfileStore.ensureUsersByIDs(e.map((e=>e.userID))),this.ui.userList.render(e)}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/BoxRoomList",["./console","Bastelstu.be/_Push","WoltLabSuite/Core/Dom/Change/Listener","WoltLabSuite/Core/Dom/Util","WoltLabSuite/Core/Timer/Repeating","Bastelstu.be/PromiseWrap/Ajax"],(function(e,t,s,i,r,n){let o;const a=new Map;class l{constructor(e){this.container=e,a.set(e,this),null==o&&(o=new r(l.updateBoxes.bind(l),6e4)),t.onConnect(o.setDelta.bind(o,3e5)).catch((e=>{})),t.onDisconnect(o.setDelta.bind(o,6e4)).catch((e=>{})),t.onMessage("be.bastelstu.chat.join",l.updateBoxes.bind(l)).catch((e=>{})),t.onMessage("be.bastelstu.chat.leave",l.updateBoxes.bind(l)).catch((e=>{}))}static updateBoxes(){a.forEach((e=>{e.update()}))}async update(){const e={className:"chat\\data\\room\\RoomAction",actionName:"getBoxRoomList",parameters:{}};e.parameters.activeRoomID=this.container.dataset.activeRoomId,e.parameters.boxID=this.container.dataset.boxId,e.parameters.isSidebar=this.container.dataset.isSidebar,e.parameters.skipEmptyRooms=this.container.dataset.skipEmptyRooms,this.replace(await n.api(this,e))}replace(e){if(null==e.returnValues.template)throw new Error("template could not be found in returnValues");const t=i.createFragmentFromHtml(e.returnValues.template),r=this.container.querySelector(".chatBoxRoomList"),n=t.querySelector(".chatBoxRoomList");if(null==r)throw new Error(".chatBoxRoomList could not be found in container");if(null==n)throw new Error(".chatBoxRoomList could not be found in returned template");r.dataset.hash!==n.dataset.hash&&(this.container.replaceChild(n,r),s.trigger())}_ajaxSetup(){return{silent:!0,ignoreError:!0}}}return l})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command",["./Parser"],(function(e){const t=Symbol("data");return class{constructor(e){this[t]=e}getParameterParser(){return e.Rest}*autocomplete(e){}get id(){return this[t].commandID}get package(){return this[t].package}get identifier(){return this[t].identifier}get module(){return this[t].module}get isAvailable(){return this[t].isAvailable}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Log",["../Ui"],(function(e){class t extends e{constructor(e,t){super(),this.messageStream=e,this.messageActionDelete=t}bootstrap(){this.messageStream.bootstrap(),this.messageStream.enableAutoscroll=!1,this.messageActionDelete.bootstrap()}}return t.DEPENDENCIES=["UiMessageStream","UiMessageActionDelete"],t})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Log",["./console","Bastelstu.be/bottle","WoltLabSuite/Core/Core","./Message","./Messenger","./ProfileStore","./Room","./Template","./Ui/Log","./Ui/MessageStream","./Ui/MessageActions/Delete"],(function(e,t,s,i,r,n,o,a,l,c,h){Symbol("loader");return class{constructor(e,u){this.config=u,this.sessionID=s.getUuid(),this.bottle=new t,this.bottle.value("bottle",this.bottle),this.bottle.value("config",u),this.bottle.constant("sessionID",this.sessionID),this.bottle.constant("roomID",e.roomID),this.service("Messenger",r),this.service("ProfileStore",n),this.service("Room",o),this.service("Ui",l),this.service("UiMessageActionDelete",h),this.service("UiMessageStream",c),this.bottle.instanceFactory("Message",((e,t)=>new i(e.MessageType,t)));const d=['[type="x-text/template"]','[data-application="be.bastelstu.chat"]',"[data-template-name]"].join("");elBySelAll(d).forEach(function(e){this.bottle.factory(`Template.${elData(e,"template-name")}`,(function(t){const s=(elData(e,"template-includes")||"").split(/ /).filter((e=>""!==e)),i={};return s.forEach((e=>i[e]=t[e])),new a(e.textContent,i)}))}.bind(this));Object.entries(this.config.messageTypes).forEach((e=>{let[t,s]=e;const i=require(s.module);this.bottle.factory(`MessageType.${t.replace(/\./g,"-")}`,(e=>{const s=this.bottle.digest(i.DEPENDENCIES||[]);return new i(...s,t)}))})),this.knows={from:void 0,to:void 0},this.messageSinks=new Set,this.params=e,this.pulling=!1}service(e,t){let s=arguments.length>2&&void 0!==arguments[2]?arguments[2]:[];this.bottle.factory(e,(function(e){const i=(t.DEPENDENCIES||[]).map((t=>e[t]));return new t(...i,...s)}))}async bootstrap(){this.ui=this.bottle.container.Ui,this.ui.bootstrap(),this.registerMessageSink(this.bottle.container.UiMessageStream),this.params.messageID>0?await Promise.all([this.pull(void 0,this.params.messageID),this.pull(this.params.messageID+1)]):await this.pull(),this.bottle.container.UiMessageStream.on("nearTop",this.pullOlder.bind(this)),this.bottle.container.UiMessageStream.on("reachedTop",this.pullOlder.bind(this)),this.bottle.container.UiMessageStream.on("nearBottom",this.pullNewer.bind(this)),this.bottle.container.UiMessageStream.on("reachedBottom",this.pullNewer.bind(this));const e=document.querySelector(`#message-${this.params.messageID}`);return window.location.hash="",window.location.hash=`message-${this.params.messageID}`,e&&e.scrollIntoView&&e.scrollIntoView(),this}registerMessageSink(e){if("function"!=typeof e.ingest)throw new Error("The given sink does not provide a .ingest function.");this.messageSinks.add(e)}unregisterMessageSink(e){this.messageSinks.delete(e)}async pull(e,t){try{await this.handlePull(await this.performPull(e,t))}catch(e){this.handleError(e)}}async pullOlder(){this.pulling||this.knows.from<=1||(this.pulling=!0,await this.pull(void 0,this.knows.from-1),this.pulling=!1)}async pullNewer(){this.pulling||(this.pulling=!0,await this.pull(this.knows.to+1),this.pulling=!1)}async performPull(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:void 0,t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:void 0;return this.bottle.container.Messenger.pull(e,t,!0)}handleError(t){e.debugException(t)}async handlePull(e){if(e.from>e.to)return;let t=e.messages;void 0!==this.knows.from&&void 0!==this.knows.to&&(t=t.filter(function(e){return!(this.knows.from<=e.messageID&&e.messageID<=this.knows.to)}.bind(this))),(void 0===this.knows.from||e.from<this.knows.from)&&(this.knows.from=e.from),(void 0===this.knows.to||e.to>this.knows.to)&&(this.knows.to=e.to),await Promise.all(t.map((e=>e.getMessageType().preProcess(e))));const s=t.map((e=>e.userID)).filter((e=>null!==e));await this.bottle.container.ProfileStore.ensureUsersByIDs(s),this.messageSinks.forEach((e=>e.ingest(t)))}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType",["WoltLabSuite/Core/Date/Util","WoltLabSuite/Core/Language","WoltLabSuite/Core/Dom/Util","Bastelstu.be/Chat/User"],(function(e,t,s,i){class r{constructor(e,t,s){this.profileStore=e,this.templates=t,this.objectType=s}shouldUpdateUserList(){return!1}getReferencedUsers(e){return null===e.userID?[]:[e.userID]}preProcess(e){}preRender(e){}render(r){const n={message:r,users:this.profileStore,author:this.profileStore.get(r.userID),DateUtil:e,Language:t};return null==n.author&&(n.author=i.getGuest(r.username)),s.createFragmentFromHtml(this.templates[r.objectType.replace(/\./g,"-")].fetch(n))}renderPlainText(e){return!1}joinable(e,t){return!1}}return r.DEPENDENCIES=["ProfileStore","Template"],r})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/Away",["../Command","../Parser"],(function(e,t){return class extends e{getParameterParser(){return t.Rest.map((e=>({reason:e})))}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/Back",["../Command","../Parser"],(function(e,t){return class extends e{getParameterParser(){return t.F.eos}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 3
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/_Suspension",["../Command","../Parser"],(function(e,t){class s extends e{constructor(e,t){super(t),this.profileStore=e}getParameterParser(){const e=t.C.string("global").thenLeft(t.C.string("ly").opt()),s=t.C.string("forever").thenReturns(null),i=t.N.digits.then(t.C.charIn("dhm")).map((function(e){let[t,s]=e;switch(s){case"d":return 86400*t;case"h":return 3600*t;case"m":return 60*t}throw new Error("Unreachable")})).rep().map((e=>e.array().reduce(((e,t)=>e+t),0))).map((e=>Math.floor(Date.now()/1e3)+e)),r=s.or(i).or(t.ISODate.map((e=>Math.floor(e.valueOf()/1e3))));return t.Username.thenLeft(t.Whitespace.rep()).then(e.thenLeft(t.Whitespace.rep()).thenReturns(!0).or(t.F.returns(!1))).then(r).then(t.Whitespace.rep().thenRight(t.Rest1).or(t.F.eos.thenReturns(null))).map((e=>{let[t,s,i,r]=e;return{username:t,globally:s,duration:i,reason:r}}))}*autocomplete(e){const s=t.Username.thenLeft(t.Whitespace.rep()).map((e=>`"${e.replace(/"/g,'""')}"`)),i=s.then(t.C.string("global").thenLeft(t.C.string("ly").opt())).thenLeft(t.Whitespace.rep()),r=s.parse(t.Streams.ofString(e));if(r.isAccepted()){const s=i.parse(t.Streams.ofString(e));let n,o;return s.isAccepted()?(n=e.substring(0,s.offset),o=e.substring(s.offset)):(n=e.substring(0,r.offset),o=e.substring(r.offset)),!s.isAccepted()&&"globally".startsWith(o)&&(yield`${n}globally `),/^[0-9]+$/.test(o)&&(yield`${n}${o}h `,yield`${n}${o}d `,yield`${n}${o}m `),void(""===o&&(yield`${n}1h `,yield`${n}1d `,yield`${n}5m `))}for(const t of this.profileStore.getLastActivity()){const s=this.profileStore.get(t);s.username.startsWith(e)&&(yield`"${s.username.replace(/"/g,'""')}" `)}}}return s.DEPENDENCIES=["ProfileStore"],s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 3
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/Ban",["./_Suspension"],(function(e){return class extends e{}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/Plain",["../Command","../Parser","WoltLabSuite/Core/StringUtil"],(function(e,t,s){class i extends e{constructor(e,t){super(t),this.profileStore=e}getParameterParser(){return t.Rest1.map(s.escapeHTML.bind(s)).map((e=>({text:e})))}*autocomplete(e){const t=e.split(/ /),s=t.pop().toLowerCase();if(""!==s)for(const i of this.profileStore.getLastActivity()){const r=this.profileStore.get(i),n=r.username.toLowerCase();(n.startsWith(e)||n.startsWith(s.replace(/^@/,"")))&&(yield`${t.concat([s.startsWith("@")?`@${r.username}`:r.username]).join(" ")} `)}}}return i.DEPENDENCIES=["ProfileStore"],i})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/Broadcast",["./Plain"],(function(e){return class extends e{}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/Color",["../Command","../Parser"],(function(e,t){return class extends e{getParameterParser(){const e=t.F.try(t.RGBHex.map((e=>({type:"hex",value:e.replace(/^#/,"")})))).or((new t.X).word().map((e=>({type:"word",value:e}))));return t.F.try(e.then(t.C.char(" ").thenRight(e))).or(e.map((e=>[e])))}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/Info",["../Command","../Parser"],(function(e,t){class s extends e{constructor(e,t){super(t),this.profileStore=e}getParameterParser(){return t.Username.map((e=>({username:e})))}*autocomplete(e){for(const t of this.profileStore.getLastActivity()){const s=this.profileStore.get(t);s.username.startsWith(e)&&(yield`"${s.username.replace(/"/g,'""')}" `)}}}return s.DEPENDENCIES=["ProfileStore"],s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/Me",["./Plain","../Parser"],(function(e,t){return class extends e{getParameterParser(){return t.Rest1.map((e=>({text:e})))}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 3
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/Mute",["./_Suspension"],(function(e){return class extends e{}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/Team",["./Plain"],(function(e){return class extends e{}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/Temproom",["../Command","../Parser"],(function(e,t){return class extends e{getParameterParser(){const e=t.C.string("create").thenReturns({type:"create"}),s=t.C.string("invite").thenLeft(t.Whitespace.rep()).thenRight(t.Username).map((e=>({type:"invite",username:e}))),i=t.C.string("delete").thenReturns({type:"delete"});return e.or(s).or(i)}*autocomplete(e){const s=t.C.string("create"),i=t.C.string("invite"),r=t.C.string("delete");s.or(i).or(r).thenLeft(t.Whitespace).parse(t.Streams.ofString(e)).isAccepted()||(yield*["create","invite ","delete"].filter((t=>t.startsWith(e))))}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 3
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/_Unsuspension",["../Command","../Parser"],(function(e,t){class s extends e{constructor(e,t){super(t),this.profileStore=e}getParameterParser(){const e=t.C.string("global").thenLeft(t.C.string("ly").opt());return t.Username.then(t.Whitespace.rep().thenRight(e.thenReturns(!0)).or(t.F.returns(!1))).map((e=>{let[t,s]=e;return{username:t,globally:s}}))}*autocomplete(e){const s=t.Username.thenLeft(t.Whitespace.rep()).map((e=>`"${e.replace(/"/g,'""')}"`)),i=s.then(t.C.string("global").thenLeft(t.C.string("ly").opt())).thenLeft(t.Whitespace.rep()),r=s.parse(t.Streams.ofString(e));if(r.isAccepted()){const s=i.parse(t.Streams.ofString(e));let n,o;s.isAccepted()?(n=e.substring(0,s.offset),o=e.substring(s.offset)):(n=e.substring(0,r.offset),o=e.substring(r.offset)),!s.isAccepted()&&"globally".startsWith(o)&&(yield`${n}globally `)}for(const t of this.profileStore.getLastActivity()){const s=this.profileStore.get(t);s.username.startsWith(e)&&(yield`"${s.username.replace(/"/g,'""')}" `)}}}return s.DEPENDENCIES=["ProfileStore"],s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 3
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/Unban",["./_Unsuspension"],(function(e){return class extends e{}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 3
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/Unmute",["./_Unsuspension"],(function(e){return class extends e{}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/Where",["../Command","../Parser"],(function(e,t){return class extends e{getParameterParser(){return t.F.eos}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Command/Whisper",["../Parser","./Plain"],(function(e,t){return class extends t{getParameterParser(){return e.Username.thenLeft(e.Whitespace.rep()).then(super.getParameterParser()).map((e=>{let[t,s]=e;return s.username=t,s}))}*autocomplete(t){if(e.Username.thenLeft(e.Whitespace).parse(e.Streams.ofString(t)).isAccepted())yield*super.autocomplete(t);else for(const e of this.profileStore.getLastActivity()){const s=this.profileStore.get(e);s.username.startsWith(t)&&(yield`"${s.username.replace(/"/g,'""')}" `)}}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/Away",["../MessageType"],(function(e){const t=["ProfileStore","roomID"].concat(e.DEPENDENCIES||[]);class s extends e{constructor(e,t){for(var s=arguments.length,i=new Array(s>2?s-2:0),r=2;r<s;r++)i[r-2]=arguments[r];super(...i),this.profileStore=e,this.roomID=t}render(e){return!e.payload.rooms.find((e=>e.roomID===this.roomID)).isSilent&&super.render(e)}shouldUpdateUserList(e){return!0}preProcess(e){this.profileStore.expire(e.userID)}}return s.DEPENDENCIES=t,s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/Back",["../MessageType"],(function(e){const t=["ProfileStore","roomID"].concat(e.DEPENDENCIES||[]);class s extends e{constructor(e,t){for(var s=arguments.length,i=new Array(s>2?s-2:0),r=2;r<s;r++)i[r-2]=arguments[r];super(...i),this.profileStore=e,this.roomID=t}render(e){return!e.payload.rooms.find((e=>e.roomID===this.roomID)).isSilent&&super.render(e)}shouldUpdateUserList(e){return!0}preProcess(e){this.profileStore.expire(e.userID)}}return s.DEPENDENCIES=t,s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/Plain",["../MessageType"],(function(e){return class extends e{joinable(e,t){return e.userID===t.userID}renderPlainText(e){return e.payload.plaintextMessage}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/Broadcast",["./Plain"],(function(e){return class extends e{renderPlainText(e){return`[📢] ${e.payload.plaintextMessage}`}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/ChatUpdate",["../MessageType"],(function(e){return class extends e{preRender(e){}render(e){return!1}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/Color",["../MessageType"],(function(e){return class extends e{render(e){return!!e.isOwnMessage()&&super.render(e)}shouldUpdateUserList(e){return!0}preProcess(e){this.profileStore.expire(e.userID)}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/Info",["WoltLabSuite/Core/Language","../Helper","../MessageType"],(function(e,t,s){const i=Symbol("decorators");return class extends s{constructor(){super(...arguments),this[i]=new Set}addDecorator(e){if("function"!=typeof e)throw new TypeError("Supplied argument must be a function");this[i].add(e)}getReferencedUsers(e){return super.getReferencedUsers(e).concat([e.payload.user.userID])}render(s){const r=s.payload.rooms.map((function(e){const s={lastPull:null,lastPullHTML:null,lastPush:null,lastPushHTML:null};return e.lastPull&&(s.lastPull=new Date(1e3*e.lastPull),s.lastPullHTML=t.getTimeElementHTML(s.lastPull)),e.lastPush&&(s.lastPush=new Date(1e3*e.lastPush),s.lastPushHTML=t.getTimeElementHTML(s.lastPush)),Object.assign({},e,s)})),n=t.deepFreeze(Array.from(this[i]).reduce(((e,t)=>t(e)),Object.assign({},s.payload,{rooms:r}))),o=super.render(new Proxy(s,{get:function(e,t){return"payload"===t?n:e[t]}})),a=document.createElement("button");a.classList.add("button","small","jsTooltip","hideIcon"),a.setAttribute("title",e.get("wcf.global.button.hide")),a.addEventListener("click",(()=>{a.closest(".chatMessageBoundary").hidden=!0}));const l=document.createElement("span");l.classList.add("icon","icon16","fa-times"),a.append(l);const c=o.querySelector(".chatMessage .containerList > li:first-child .containerHeadline");return c.insertBefore(a,c.firstChild),o}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/Join",["../MessageType","WoltLabSuite/Core/Language"],(function(e,t){return class extends e{shouldUpdateUserList(e){return!0}renderPlainText(e){return"[➡️] "+t.get("chat.messageType.be.bastelstu.chat.messageType.join.plain",{author:{username:e.username}})}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/Leave",["../MessageType","WoltLabSuite/Core/Language"],(function(e,t){return class extends e{shouldUpdateUserList(e){return!0}renderPlainText(e){return"[⬅️️] "+t.get("chat.messageType.be.bastelstu.chat.messageType.leave.plain",{author:{username:e.username}})}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/Me",["../MessageType"],(function(e){return class extends e{}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/Suspend",["../Helper","WoltLabSuite/Core/Date/Util","../MessageType"],(function(e,t,s){return class extends s{render(s){const i=null!==s.payload.suspension.expires?new Date(1e3*s.payload.suspension.expires):null,r={expires:i,formattedExpires:null!==i?t.formatDateTime(i):null},n=Object.assign({},s.payload.suspension,r),o=e.deepFreeze(Object.assign({},s.payload,{suspension:n}));return super.render(new Proxy(s,{get:function(e,t){return"payload"===t?o:e[t]}}))}shouldUpdateUserList(e){return!0}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/Team",["./Plain"],(function(e){return class extends e{joinable(e,t){return e.userID===t.userID}renderPlainText(e){return`[⭐] ${e.payload.plaintextMessage}`}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/TemproomCreated",["../MessageType"],(function(e){return class extends e{}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/TemproomInvited",["../MessageType"],(function(e){return class extends e{}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/Tombstone",["../MessageType"],(function(e){const t=["UiMessageStream"].concat(e.DEPENDENCIES||[]);class s extends e{constructor(e){for(var t=arguments.length,s=new Array(t>1?t-1:0),i=1;i<t;i++)s[i-1]=arguments[i];super(...s),this.messageStream=e}render(e){if(e.isDeleted)return super.render(e);const t=e.payload.messageID,s=elById(`message-${t}`);if(!s)return!1;s.classList.add("tombstone");const i=s.querySelector(".chatMessage");if(!i)return!1;const r=super.render(e),n=s.querySelector(".chatMessageContent > .chatMessageIcon"),o=r.querySelector(".chatMessageIcon");return n?n.parentNode.replaceChild(o,n):i.parentNode.insertBefore(o,i),i.parentNode.replaceChild(r.querySelector(".chatMessage"),i),!1}}return s.DEPENDENCIES=t,s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/Unsuspend",["../MessageType"],(function(e){return class extends e{shouldUpdateUserList(e){return!0}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/Where",["WoltLabSuite/Core/Language","../MessageType"],(function(e,t){return class extends t{render(t){const s=super.render(t),i=document.createElement("button");i.classList.add("button","small","jsTooltip","hideIcon"),i.setAttribute("title",e.get("wcf.global.button.hide")),i.addEventListener("click",(()=>{i.closest(".chatMessageBoundary").hidden=!0}));const r=document.createElement("span");r.classList.add("icon","icon16","fa-times"),i.append(r);const n=s.querySelector(".jsRoomInfo > .containerHeadline");return n.insertBefore(i,n.firstChild),s}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/MessageType/Whisper",["./Plain"],(function(e){const t=["UiInput"].concat(e.DEPENDENCIES||[]);class s extends e{constructor(e){for(var t=arguments.length,s=new Array(t>1?t-1:0),i=1;i<t;i++)s[i-1]=arguments[i];super(...s),this.input=e}render(e){const t=super.render(e);return null!=this.input&&Array.prototype.forEach.call(t.querySelectorAll("[data-insert-whisper]"),function(e){e.addEventListener("click",function(){const t=`/whisper "${e.dataset.insertWhisper.replace(/"/g,'""')}"`;0!==this.input.getText().indexOf(t)&&(this.input.insertText(`${t} `,{prepend:!0,append:!1}),this.input.focus())}.bind(this))}.bind(this)),t}joinable(e,t){return e.userID===t.userID&&e.payload.recipient===t.payload.recipient}}return s.DEPENDENCIES=t,s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Settings/Button",[],(function(){class e{constructor(e){if(!e||!e instanceof Element)throw new Error("No DOM element provided");this.element=e}bootstrap(){this.element.addEventListener("click",this.onClick.bind(this))}onClick(e){e.preventDefault()}}return e.DEPENDENCIES=[],e})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Settings/ToggleButton",["./Button","../../LocalStorage","../../DataStructure/EventEmitter"],(function(e,t,s){const i=[].concat(e.DEPENDENCIES||[]);class r extends e{constructor(e,s,i){for(var r=arguments.length,n=new Array(r>3?r-3:0),o=3;o<r;o++)n[o-3]=arguments[o];super(e,...n),this.initialized=!1,this.storage=new t("Settings."),this.storageKey=i,this.storage.has(this.storageKey)&&(s=this.storage.get(this.storageKey)),this.defaultState=s}bootstrap(){super.bootstrap(),this.defaultState?this.enable():this.disable()}get enabled(){return this.element.classList.contains("active")}enable(){this.element.classList.add("active"),null!=this.storageKey&&this.storage.set(this.storageKey,!0)}disable(){this.element.classList.remove("active"),null!=this.storageKey&&this.storage.set(this.storageKey,!1)}onClick(e){super.onClick(e),this.enabled?this.disable():this.enable()}}return s(r.prototype),r.DEPENDENCIES=i,r})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Settings/AutoscrollButton",["./ToggleButton"],(function(e){const t=["UiMessageStream"].concat(e.DEPENDENCIES||[]);class s extends e{constructor(e,t){for(var s=arguments.length,i=new Array(s>2?s-2:0),r=2;r<s;r++)i[r-2]=arguments[r];super(e,!0,void 0,...i),this.messageStream=t,this.messageStream.on("reachedBottom",this.enable.bind(this)),this.messageStream.on("scrollUp",this.disable.bind(this))}enable(){super.enable(),this.messageStream.enableAutoscroll=!0}disable(){super.disable(),this.messageStream.enableAutoscroll=!1}}return s.DEPENDENCIES=t,s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Settings/FullscreenButton",["./ToggleButton"],(function(e){return class extends e{constructor(e){for(var t=arguments.length,s=new Array(t>1?t-1:0),i=1;i<t;i++)s[i-1]=arguments[i];super(e,!1,"Bastelstu.be/Chat/Ui/Settings/FullscreenButton",...s)}enable(){super.enable(),document.querySelector("html").classList.add("fullscreen")}disable(){super.disable(),document.querySelector("html").classList.remove("fullscreen")}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Settings/NotificationsButton",["./ToggleButton"],(function(e){const t=["UiNotification"].concat(e.DEPENDENCIES||[]);class s extends e{constructor(e,t){for(var s=arguments.length,i=new Array(s>2?s-2:0),r=2;r<s;r++)i[r-2]=arguments[r];super(e,!1,"Bastelstu.be/Chat/Ui/Settings/NotificationsButton",...i),this.notification=t}bootstrap(){super.bootstrap(),this.notification.systemSupported&&!this.notification.systemDenied||elRemove(this.element.closest("li"))}enable(){super.enable(),this.notification.enableSystemNotifications().catch((e=>{this.disable(),this.notification.systemDenied&&elRemove(this.element)}))}disable(){super.disable(),this.notification.disableSystemNotifications()}}return s.DEPENDENCIES=t,s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Settings/RoomListButton",["../../Helper","./Button","WoltLabSuite/Core/Dom/Util","WoltLabSuite/Core/Language","WoltLabSuite/Core/Ui/Screen"],(function(e,t,s,i,r){const n=[].concat(t.DEPENDENCIES||[]);class o extends t{constructor(e){for(var t=arguments.length,s=new Array(t>1?t-1:0),i=1;i<t;i++)s[i-1]=arguments[i];super(e,...s),this.roomList=document.querySelector("[data-box-identifier='be.bastelstu.chat.roomListSidebar']"),this.roomList?(this.mobile=!1,this.open=!1,this.sidebar=document.querySelector(".sidebar"),r.on("screen-xs",{match:()=>this.enableMobile(),unmatch:()=>this.disableMobile(),setup:()=>this.enableMobile()})):e.remove()}enableMobile(){this.mobile=!0,this.element.parentElement.hidden=!1}disableMobile(){this.open&&this.show(!1),this.element.parentElement.hidden=!0,this.mobile=!1}show(){if(!(arguments.length>0&&void 0!==arguments[0])||arguments[0]){this.open=!0,this.sidebar.style.setProperty("display","contents","");for(let t of e.getElementSiblings(this.roomList))s.hide(t);this.closeButton=document.createElement("span"),this.closeButton.classList.add("modalCloseButton"),this.closeButton.innerText=i.get("wcf.global.button.close"),this.closeButton.addEventListener("click",(()=>this.show(!1))),this.roomList.appendChild(this.closeButton),this.roomList.dataset.show="true",this.mobile&&r.scrollDisable()}else{delete this.roomList.dataset.show,this.closeButton.remove();for(let t of e.getElementSiblings(this.roomList))s.show(t);this.sidebar.style.removeProperty("display"),this.open=!1,this.mobile&&r.scrollEnable()}}async onClick(e){super.onClick(e),this.show(!this.open)}}return o.DEPENDENCIES=n,o})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Settings/SmiliesButton",["./ToggleButton","WoltLabSuite/Core/Ui/Screen"],(function(e,t){const s=["UiInput"].concat(e.DEPENDENCIES||[]);class i extends e{constructor(e,t){for(var s=arguments.length,i=new Array(s>2?s-2:0),r=2;r<s;r++)i[r-2]=arguments[r];super(e,!1,void 0,...i),this.input=t}bootstrap(){this.container=elById("smileyPickerContainer"),this.container||elRemove(this.element.closest("li")),this.closeButton=elById("smileyPickerCloseButton"),$(".messageTabMenu").messageTabMenu(),$("#smilies-text").on("mousedown",".jsSmiley",this.insertSmiley.bind(this)),this.closeButton.addEventListener("mousedown",this.disable.bind(this)),this.mobile=!1,super.bootstrap(),t.on("screen-md-down",{match:this.enableMobile.bind(this),unmatch:this.disableMobile.bind(this),setup:this.setupMobile.bind(this)})}setupMobile(){this.shadowToggleButton=document.createElement("span"),this.shadowToggleButton.classList.add("smiliesToggleMobileButton","button","small"),this.shadowToggleButton.innerHTML='<span class="icon icon24 fa-smile-o"></span>',this.shadowToggleButton.addEventListener("mousedown",this.onClick.bind(this));const e=elBySel("#chatInputContainer > div");e.insertBefore(this.shadowToggleButton,e.firstChild),this.enableMobile()}enableMobile(){this.mobile=!0,elHide(this.element.parentElement),elShow(this.shadowToggleButton),this.disable()}disableMobile(){this.mobile=!1,elShow(this.element.parentElement),elHide(this.shadowToggleButton),t.scrollEnable()}insertSmiley(e){e.preventDefault(),e.stopPropagation();const t=e.currentTarget.children[0].getAttribute("alt");this.input.insertText(` ${t} `),this.mobile&&this.disable()}enable(){super.enable(),elShow(this.container),elData(this.container,"show","true"),this.mobile&&t.scrollDisable()}disable(){super.disable(),elHide(this.container),elData(this.container,"show","false"),this.mobile&&t.scrollEnable()}}return i.DEPENDENCIES=s,i})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/Settings/UserListButton",["../../Helper","./Button","WoltLabSuite/Core/Dom/Util","WoltLabSuite/Core/Language","WoltLabSuite/Core/Ui/Screen"],(function(e,t,s,i,r){const n=[].concat(t.DEPENDENCIES||[]);class o extends t{constructor(e){for(var t=arguments.length,s=new Array(t>1?t-1:0),i=1;i<t;i++)s[i-1]=arguments[i];super(e,...s),this.mobile=!1,this.open=!1,this.userList=document.getElementById("chatUserList"),this.sidebar=document.querySelector(".sidebar"),r.on("screen-xs",{match:()=>this.enableMobile(),unmatch:()=>this.disableMobile(),setup:()=>this.enableMobile()})}enableMobile(){this.mobile=!0,this.element.parentElement.hidden=!1}disableMobile(){this.open&&this.show(!1),this.element.parentElement.hidden=!0,this.mobile=!1}show(){if(!(arguments.length>0&&void 0!==arguments[0])||arguments[0]){this.open=!0,this.sidebar.style.setProperty("display","contents","");for(let t of e.getElementSiblings(this.userList))s.hide(t);this.closeButton=document.createElement("span"),this.closeButton.classList.add("modalCloseButton"),this.closeButton.innerText=i.get("wcf.global.button.close"),this.closeButton.addEventListener("click",(()=>this.show(!1))),this.userList.appendChild(this.closeButton),this.userList.dataset.show="true",this.mobile&&r.scrollDisable()}else{delete this.userList.dataset.show,this.closeButton.remove();for(let t of e.getElementSiblings(this.userList))s.show(t);this.sidebar.style.removeProperty("display"),this.open=!1,this.mobile&&r.scrollEnable()}}async onClick(e){super.onClick(e),this.show(!this.open)}}return o.DEPENDENCIES=n,o})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/UserActions/Action",[],(function(){return class{constructor(){}onClick(e,t){}}})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/UserActions/BanAction",["../../console","./Action"],(function(e,t){class s extends t{constructor(e){super(),this.input=e}onClick(t,s){if(!s.target.dataset.trigger)return void e.warn("[WhisperAction]","Missing trigger");const i=t.username.replace(/"/g,'""'),r=`/${s.target.dataset.trigger} "${i}" `;this.input.insertText(r,{append:!1,prepend:!0}),this.input.focus(),setTimeout((e=>{this.input.emit("autocomplete")}),1)}}return s.DEPENDENCIES=["UiInput"],s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/UserActions/MuteAction",["../../console","./Action"],(function(e,t){class s extends t{constructor(e){super(),this.input=e}onClick(t,s){if(!s.target.dataset.trigger)return void e.warn("[WhisperAction]","Missing trigger");const i=t.username.replace(/"/g,'""'),r=`/${s.target.dataset.trigger} "${i}" `;this.input.insertText(r,{append:!1,prepend:!0}),this.input.focus(),setTimeout((e=>{this.input.emit("autocomplete")}),1)}}return s.DEPENDENCIES=["UiInput"],s})),
/*
 * Copyright (c) 2010-2024 Tim Düsterhus.
 *
 * Use of this software is governed by the Business Source License
 * included in the LICENSE file.
 *
 * Change Date: 2028-01-13
 *
 * On the date above, in accordance with the Business Source
 * License, use of this software will be governed by version 2
 * or later of the General Public License.
 */
define("Bastelstu.be/Chat/Ui/UserActions/WhisperAction",["./Action","../../console"],(function(e,t){class s extends e{constructor(e){super(),this.input=e}onClick(e,s){if(!s.target.dataset.trigger)return void t.warn("[WhisperAction]","Missing trigger");const i=e.username.replace(/"/g,'""'),r=`/${s.target.dataset.trigger} "${i}" `;this.input.insertText(r,{append:!1,prepend:!0}),this.input.focus()}}return s.DEPENDENCIES=["UiInput"],s}));